diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index c4f993b8f7..2b82dc14f0 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -751,14 +751,20 @@ static ObjectAddress get_object_address_defacl(List *object,
 						  bool missing_ok);
 static const ObjectPropertyType *get_object_property_data(Oid class_id);
 
-static void getRelationDescription(StringInfo buffer, Oid relid);
-static void getOpFamilyDescription(StringInfo buffer, Oid opfid);
+static void getRelationDescription(StringInfo buffer, Oid relid,
+								   bool missing_ok);
+static void getOpFamilyDescription(StringInfo buffer, Oid opfid,
+								   bool missing_ok);
 static void getRelationTypeDescription(StringInfo buffer, Oid relid,
-						   int32 objectSubId);
-static void getProcedureTypeDescription(StringInfo buffer, Oid procid);
-static void getConstraintTypeDescription(StringInfo buffer, Oid constroid);
-static void getOpFamilyIdentity(StringInfo buffer, Oid opfid, List **object);
-static void getRelationIdentity(StringInfo buffer, Oid relid, List **object);
+									   int32 objectSubId, bool missing_ok);
+static void getProcedureTypeDescription(StringInfo buffer, Oid procid,
+										bool missing_ok);
+static void getConstraintTypeDescription(StringInfo buffer, Oid constroid,
+										 bool missing_ok);
+static void getOpFamilyIdentity(StringInfo buffer, Oid opfid, List **object,
+								bool missing_ok);
+static void getRelationIdentity(StringInfo buffer, Oid relid, List **object,
+								bool missing_ok);
 
 /*
  * Translate an object name and arguments (as passed by the parser) to an
@@ -1626,7 +1632,7 @@ get_object_address_opf_member(ObjectType objtype,
 										membernum,
 										TypeNameToString(typenames[0]),
 										TypeNameToString(typenames[1]),
-										getObjectDescription(&famaddr))));
+										getObjectDescription(&famaddr, false))));
 				}
 				else
 				{
@@ -1657,7 +1663,7 @@ get_object_address_opf_member(ObjectType objtype,
 										membernum,
 										TypeNameToString(typenames[0]),
 										TypeNameToString(typenames[1]),
-										getObjectDescription(&famaddr))));
+										getObjectDescription(&famaddr, false))));
 				}
 				else
 				{
@@ -2649,10 +2655,12 @@ get_catalog_object_by_oid(Relation catalog, Oid objectId)
 /*
  * getObjectDescription: build an object description for messages
  *
- * The result is a palloc'd string.
+ * The result is a palloc'd string. In the event of an undefined object,
+ * NULL is returned if missing_ok is true. If missing_ok is false an
+ * error is generated instead.
  */
 char *
-getObjectDescription(const ObjectAddress *object)
+getObjectDescription(const ObjectAddress *object, bool missing_ok)
 {
 	StringInfoData buffer;
 
@@ -2661,22 +2669,28 @@ getObjectDescription(const ObjectAddress *object)
 	switch (getObjectClass(object))
 	{
 		case OCLASS_CLASS:
-			getRelationDescription(&buffer, object->objectId);
+			getRelationDescription(&buffer, object->objectId, missing_ok);
 			if (object->objectSubId != 0)
-				appendStringInfo(&buffer, _(" column %s"),
-								 get_attname(object->objectId,
-											 object->objectSubId,
-											 false));
+			{
+				char *attname = get_attname(object->objectId,
+											object->objectSubId,
+											missing_ok);
+				if (attname)
+					appendStringInfo(&buffer, _(" column %s"), attname);
+			}
 			break;
 
 		case OCLASS_PROC:
+			/* returns numerical OID for undefined function */
 			appendStringInfo(&buffer, _("function %s"),
 							 format_procedure(object->objectId));
 			break;
 
 		case OCLASS_TYPE:
+			/* returns "???" for undefined type */
 			appendStringInfo(&buffer, _("type %s"),
-							 format_type_be(object->objectId));
+							 format_type_extended(object->objectId, -1,
+												  false, missing_ok, false));
 			break;
 
 		case OCLASS_CAST:
@@ -2699,15 +2713,19 @@ getObjectDescription(const ObjectAddress *object)
 
 				tup = systable_getnext(rcscan);
 
-				if (!HeapTupleIsValid(tup))
+				if (HeapTupleIsValid(tup))
+				{
+					castForm = (Form_pg_cast) GETSTRUCT(tup);
+
+					appendStringInfo(&buffer, _("cast from %s to %s"),
+									 format_type_be(castForm->castsource),
+									 format_type_be(castForm->casttarget));
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "could not find tuple for cast %u",
 						 object->objectId);
-
-				castForm = (Form_pg_cast) GETSTRUCT(tup);
-
-				appendStringInfo(&buffer, _("cast from %s to %s"),
-								 format_type_be(castForm->castsource),
-								 format_type_be(castForm->casttarget));
+				}
 
 				systable_endscan(rcscan);
 				heap_close(castDesc, AccessShareLock);
@@ -2721,13 +2739,18 @@ getObjectDescription(const ObjectAddress *object)
 
 				collTup = SearchSysCache1(COLLOID,
 										  ObjectIdGetDatum(object->objectId));
-				if (!HeapTupleIsValid(collTup))
+				if (HeapTupleIsValid(collTup))
+				{
+					coll = (Form_pg_collation) GETSTRUCT(collTup);
+					appendStringInfo(&buffer, _("collation %s"),
+									 NameStr(coll->collname));
+					ReleaseSysCache(collTup);
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "cache lookup failed for collation %u",
 						 object->objectId);
-				coll = (Form_pg_collation) GETSTRUCT(collTup);
-				appendStringInfo(&buffer, _("collation %s"),
-								 NameStr(coll->collname));
-				ReleaseSysCache(collTup);
+				}
 				break;
 			}
 
@@ -2739,8 +2762,14 @@ getObjectDescription(const ObjectAddress *object)
 				conTup = SearchSysCache1(CONSTROID,
 										 ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(conTup))
+				{
+					if (missing_ok)
+						break;
+
 					elog(ERROR, "cache lookup failed for constraint %u",
 						 object->objectId);
+				}
+
 				con = (Form_pg_constraint) GETSTRUCT(conTup);
 
 				if (OidIsValid(con->conrelid))
@@ -2748,7 +2777,7 @@ getObjectDescription(const ObjectAddress *object)
 					StringInfoData rel;
 
 					initStringInfo(&rel);
-					getRelationDescription(&rel, con->conrelid);
+					getRelationDescription(&rel, con->conrelid, false);
 					appendStringInfo(&buffer, _("constraint %s on %s"),
 									 NameStr(con->conname), rel.data);
 					pfree(rel.data);
@@ -2770,8 +2799,13 @@ getObjectDescription(const ObjectAddress *object)
 				conTup = SearchSysCache1(CONVOID,
 										 ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(conTup))
+				{
+					if (missing_ok)
+						break;
+
 					elog(ERROR, "cache lookup failed for conversion %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("conversion %s"),
 								 NameStr(((Form_pg_conversion) GETSTRUCT(conTup))->conname));
 				ReleaseSysCache(conTup);
@@ -2799,18 +2833,22 @@ getObjectDescription(const ObjectAddress *object)
 
 				tup = systable_getnext(adscan);
 
-				if (!HeapTupleIsValid(tup))
-					elog(ERROR, "could not find tuple for attrdef %u",
-						 object->objectId);
-
-				attrdef = (Form_pg_attrdef) GETSTRUCT(tup);
+				if (HeapTupleIsValid(tup))
+				{
+					attrdef = (Form_pg_attrdef) GETSTRUCT(tup);
 
-				colobject.classId = RelationRelationId;
-				colobject.objectId = attrdef->adrelid;
-				colobject.objectSubId = attrdef->adnum;
+					colobject.classId = RelationRelationId;
+					colobject.objectId = attrdef->adrelid;
+					colobject.objectSubId = attrdef->adnum;
 
-				appendStringInfo(&buffer, _("default for %s"),
-								 getObjectDescription(&colobject));
+					appendStringInfo(&buffer, _("default for %s"),
+									 getObjectDescription(&colobject, false));
+				}
+				else if (!missing_ok)
+				{
+					elog(ERROR, "could not find tuple for attrdef %u",
+						 object->objectId);
+				}
 
 				systable_endscan(adscan);
 				heap_close(attrdefDesc, AccessShareLock);
@@ -2818,9 +2856,15 @@ getObjectDescription(const ObjectAddress *object)
 			}
 
 		case OCLASS_LANGUAGE:
-			appendStringInfo(&buffer, _("language %s"),
-							 get_language_name(object->objectId, false));
-			break;
+			{
+				char *langname = get_language_name(object->objectId,
+												   missing_ok);
+
+				if (langname)
+					appendStringInfo(&buffer, _("language %s"),
+									 get_language_name(object->objectId, false));
+				break;
+			}
 
 		case OCLASS_LARGEOBJECT:
 			appendStringInfo(&buffer, _("large object %u"),
@@ -2828,6 +2872,7 @@ getObjectDescription(const ObjectAddress *object)
 			break;
 
 		case OCLASS_OPERATOR:
+			/* returns numerical OID for undefined operator */
 			appendStringInfo(&buffer, _("operator %s"),
 							 format_operator(object->objectId));
 			break;
@@ -2843,8 +2888,13 @@ getObjectDescription(const ObjectAddress *object)
 				opcTup = SearchSysCache1(CLAOID,
 										 ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(opcTup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for opclass %u",
 						 object->objectId);
+				}
+
 				opcForm = (Form_pg_opclass) GETSTRUCT(opcTup);
 
 				amTup = SearchSysCache1(AMOID,
@@ -2871,7 +2921,7 @@ getObjectDescription(const ObjectAddress *object)
 			}
 
 		case OCLASS_OPFAMILY:
-			getOpFamilyDescription(&buffer, object->objectId);
+			getOpFamilyDescription(&buffer, object->objectId, missing_ok);
 			break;
 
 		case OCLASS_AM:
@@ -2881,8 +2931,13 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(AMOID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for access method %u",
 						 object->objectId);
+				}
+
 				appendStringInfo(&buffer, _("access method %s"),
 								 NameStr(((Form_pg_am) GETSTRUCT(tup))->amname));
 				ReleaseSysCache(tup);
@@ -2911,28 +2966,32 @@ getObjectDescription(const ObjectAddress *object)
 
 				tup = systable_getnext(amscan);
 
-				if (!HeapTupleIsValid(tup))
+				if (HeapTupleIsValid(tup))
+				{
+					amopForm = (Form_pg_amop) GETSTRUCT(tup);
+
+					initStringInfo(&opfam);
+					getOpFamilyDescription(&opfam, amopForm->amopfamily, false);
+
+					/*------
+					   translator: %d is the operator strategy (a number), the
+					   first two %s's are data type names, the third %s is the
+					   description of the operator family, and the last %s is
+					   the textual form of the operator with arguments.  */
+					appendStringInfo(&buffer, _("operator %d (%s, %s) of %s: %s"),
+									 amopForm->amopstrategy,
+									 format_type_be(amopForm->amoplefttype),
+									 format_type_be(amopForm->amoprighttype),
+									 opfam.data,
+									 format_operator(amopForm->amopopr));
+
+					pfree(opfam.data);
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "could not find tuple for amop entry %u",
 						 object->objectId);
-
-				amopForm = (Form_pg_amop) GETSTRUCT(tup);
-
-				initStringInfo(&opfam);
-				getOpFamilyDescription(&opfam, amopForm->amopfamily);
-
-				/*------
-				   translator: %d is the operator strategy (a number), the
-				   first two %s's are data type names, the third %s is the
-				   description of the operator family, and the last %s is the
-				   textual form of the operator with arguments.  */
-				appendStringInfo(&buffer, _("operator %d (%s, %s) of %s: %s"),
-								 amopForm->amopstrategy,
-								 format_type_be(amopForm->amoplefttype),
-								 format_type_be(amopForm->amoprighttype),
-								 opfam.data,
-								 format_operator(amopForm->amopopr));
-
-				pfree(opfam.data);
+				}
 
 				systable_endscan(amscan);
 				heap_close(amopDesc, AccessShareLock);
@@ -2961,28 +3020,32 @@ getObjectDescription(const ObjectAddress *object)
 
 				tup = systable_getnext(amscan);
 
-				if (!HeapTupleIsValid(tup))
+				if (HeapTupleIsValid(tup))
+				{
+					amprocForm = (Form_pg_amproc) GETSTRUCT(tup);
+
+					initStringInfo(&opfam);
+					getOpFamilyDescription(&opfam, amprocForm->amprocfamily, false);
+
+					/*------
+					   translator: %d is the function number, the first two
+					   %s's are data type names, the third %s is the description
+					   of the operator family, and the last %s is the textual
+					   form of the function with arguments.  */
+					appendStringInfo(&buffer, _("function %d (%s, %s) of %s: %s"),
+									 amprocForm->amprocnum,
+									 format_type_be(amprocForm->amproclefttype),
+									 format_type_be(amprocForm->amprocrighttype),
+									 opfam.data,
+									 format_procedure(amprocForm->amproc));
+
+					pfree(opfam.data);
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "could not find tuple for amproc entry %u",
 						 object->objectId);
-
-				amprocForm = (Form_pg_amproc) GETSTRUCT(tup);
-
-				initStringInfo(&opfam);
-				getOpFamilyDescription(&opfam, amprocForm->amprocfamily);
-
-				/*------
-				   translator: %d is the function number, the first two %s's
-				   are data type names, the third %s is the description of the
-				   operator family, and the last %s is the textual form of the
-				   function with arguments.  */
-				appendStringInfo(&buffer, _("function %d (%s, %s) of %s: %s"),
-								 amprocForm->amprocnum,
-								 format_type_be(amprocForm->amproclefttype),
-								 format_type_be(amprocForm->amprocrighttype),
-								 opfam.data,
-								 format_procedure(amprocForm->amproc));
-
-				pfree(opfam.data);
+				}
 
 				systable_endscan(amscan);
 				heap_close(amprocDesc, AccessShareLock);
@@ -3009,15 +3072,19 @@ getObjectDescription(const ObjectAddress *object)
 
 				tup = systable_getnext(rcscan);
 
-				if (!HeapTupleIsValid(tup))
+				if (HeapTupleIsValid(tup))
+				{
+					rule = (Form_pg_rewrite) GETSTRUCT(tup);
+
+					appendStringInfo(&buffer, _("rule %s on "),
+									 NameStr(rule->rulename));
+					getRelationDescription(&buffer, rule->ev_class, false);
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "could not find tuple for rule %u",
 						 object->objectId);
-
-				rule = (Form_pg_rewrite) GETSTRUCT(tup);
-
-				appendStringInfo(&buffer, _("rule %s on "),
-								 NameStr(rule->rulename));
-				getRelationDescription(&buffer, rule->ev_class);
+				}
 
 				systable_endscan(rcscan);
 				heap_close(ruleDesc, AccessShareLock);
@@ -3044,15 +3111,19 @@ getObjectDescription(const ObjectAddress *object)
 
 				tup = systable_getnext(tgscan);
 
-				if (!HeapTupleIsValid(tup))
+				if (HeapTupleIsValid(tup))
+				{
+					trig = (Form_pg_trigger) GETSTRUCT(tup);
+
+					appendStringInfo(&buffer, _("trigger %s on "),
+									 NameStr(trig->tgname));
+					getRelationDescription(&buffer, trig->tgrelid, false);
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "could not find tuple for trigger %u",
 						 object->objectId);
-
-				trig = (Form_pg_trigger) GETSTRUCT(tup);
-
-				appendStringInfo(&buffer, _("trigger %s on "),
-								 NameStr(trig->tgname));
-				getRelationDescription(&buffer, trig->tgrelid);
+				}
 
 				systable_endscan(tgscan);
 				heap_close(trigDesc, AccessShareLock);
@@ -3065,8 +3136,12 @@ getObjectDescription(const ObjectAddress *object)
 
 				nspname = get_namespace_name(object->objectId);
 				if (!nspname)
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for namespace %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("schema %s"), nspname);
 				break;
 			}
@@ -3079,8 +3154,12 @@ getObjectDescription(const ObjectAddress *object)
 				stxTup = SearchSysCache1(STATEXTOID,
 										 ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(stxTup))
-					elog(ERROR, "could not find tuple for statistics object %u",
+				{
+					if (missing_ok)
+						break;
+					elog(ERROR, "cache lookup failed for statistics object %u",
 						 object->objectId);
+				}
 
 				stxForm = (Form_pg_statistic_ext) GETSTRUCT(stxTup);
 
@@ -3098,8 +3177,12 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(TSPARSEROID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for text search parser %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("text search parser %s"),
 								 NameStr(((Form_pg_ts_parser) GETSTRUCT(tup))->prsname));
 				ReleaseSysCache(tup);
@@ -3113,8 +3196,12 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(TSDICTOID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for text search dictionary %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("text search dictionary %s"),
 								 NameStr(((Form_pg_ts_dict) GETSTRUCT(tup))->dictname));
 				ReleaseSysCache(tup);
@@ -3128,8 +3215,12 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(TSTEMPLATEOID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for text search template %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("text search template %s"),
 								 NameStr(((Form_pg_ts_template) GETSTRUCT(tup))->tmplname));
 				ReleaseSysCache(tup);
@@ -3143,8 +3234,12 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(TSCONFIGOID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for text search configuration %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("text search configuration %s"),
 								 NameStr(((Form_pg_ts_config) GETSTRUCT(tup))->cfgname));
 				ReleaseSysCache(tup);
@@ -3153,8 +3248,11 @@ getObjectDescription(const ObjectAddress *object)
 
 		case OCLASS_ROLE:
 			{
-				appendStringInfo(&buffer, _("role %s"),
-								 GetUserNameFromId(object->objectId, false));
+				char	  *username = GetUserNameFromId(object->objectId,
+														missing_ok);
+
+				if (username)
+					appendStringInfo(&buffer, _("role %s"), username);
 				break;
 			}
 
@@ -3164,8 +3262,12 @@ getObjectDescription(const ObjectAddress *object)
 
 				datname = get_database_name(object->objectId);
 				if (!datname)
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for database %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("database %s"), datname);
 				break;
 			}
@@ -3176,8 +3278,12 @@ getObjectDescription(const ObjectAddress *object)
 
 				tblspace = get_tablespace_name(object->objectId);
 				if (!tblspace)
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for tablespace %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("tablespace %s"), tblspace);
 				break;
 			}
@@ -3186,8 +3292,9 @@ getObjectDescription(const ObjectAddress *object)
 			{
 				ForeignDataWrapper *fdw;
 
-				fdw = GetForeignDataWrapper(object->objectId, false);
-				appendStringInfo(&buffer, _("foreign-data wrapper %s"), fdw->fdwname);
+				fdw = GetForeignDataWrapper(object->objectId, missing_ok);
+				if (fdw)
+					appendStringInfo(&buffer, _("foreign-data wrapper %s"), fdw->fdwname);
 				break;
 			}
 
@@ -3195,8 +3302,9 @@ getObjectDescription(const ObjectAddress *object)
 			{
 				ForeignServer *srv;
 
-				srv = GetForeignServer(object->objectId, false);
-				appendStringInfo(&buffer, _("server %s"), srv->servername);
+				srv = GetForeignServer(object->objectId, missing_ok);
+				if (srv)
+					appendStringInfo(&buffer, _("server %s"), srv->servername);
 				break;
 			}
 
@@ -3211,8 +3319,13 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(USERMAPPINGOID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for user mapping %u",
 						 object->objectId);
+				}
+
 				umform = (Form_pg_user_mapping) GETSTRUCT(tup);
 				useid = umform->umuser;
 				srv = GetForeignServer(umform->umserver, false);
@@ -3250,8 +3363,16 @@ getObjectDescription(const ObjectAddress *object)
 				tup = systable_getnext(rcscan);
 
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+					{
+						systable_endscan(rcscan);
+						heap_close(defaclrel, AccessShareLock);
+						break;
+					}
 					elog(ERROR, "could not find tuple for default ACL %u",
 						 object->objectId);
+				}
 
 				defacl = (Form_pg_default_acl) GETSTRUCT(tup);
 
@@ -3308,8 +3429,12 @@ getObjectDescription(const ObjectAddress *object)
 
 				extname = get_extension_name(object->objectId);
 				if (!extname)
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for extension %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("extension %s"), extname);
 				break;
 			}
@@ -3321,8 +3446,12 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(EVENTTRIGGEROID,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for event trigger %u",
 						 object->objectId);
+				}
 				appendStringInfo(&buffer, _("event trigger %s"),
 								 NameStr(((Form_pg_event_trigger) GETSTRUCT(tup))->evtname));
 				ReleaseSysCache(tup);
@@ -3349,15 +3478,20 @@ getObjectDescription(const ObjectAddress *object)
 
 				tuple = systable_getnext(sscan);
 
-				if (!HeapTupleIsValid(tuple))
+				if (HeapTupleIsValid(tuple))
+				{
+					form_policy = (Form_pg_policy) GETSTRUCT(tuple);
+
+					appendStringInfo(&buffer, _("policy %s on "),
+									 NameStr(form_policy->polname));
+					getRelationDescription(&buffer, form_policy->polrelid,
+										   false);
+				}
+				else if (!missing_ok)
+				{
 					elog(ERROR, "could not find tuple for policy %u",
 						 object->objectId);
-
-				form_policy = (Form_pg_policy) GETSTRUCT(tuple);
-
-				appendStringInfo(&buffer, _("policy %s on "),
-								 NameStr(form_policy->polname));
-				getRelationDescription(&buffer, form_policy->polrelid);
+				}
 
 				systable_endscan(sscan);
 				heap_close(policy_rel, AccessShareLock);
@@ -3366,9 +3500,11 @@ getObjectDescription(const ObjectAddress *object)
 
 		case OCLASS_PUBLICATION:
 			{
-				appendStringInfo(&buffer, _("publication %s"),
-								 get_publication_name(object->objectId,
-													  false));
+				char *pubname = get_publication_name(object->objectId,
+													 missing_ok);
+
+				if (pubname)
+					appendStringInfo(&buffer, _("publication %s"), pubname);
 				break;
 			}
 
@@ -3381,8 +3517,12 @@ getObjectDescription(const ObjectAddress *object)
 				tup = SearchSysCache1(PUBLICATIONREL,
 									  ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(tup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "cache lookup failed for publication table %u",
 						 object->objectId);
+				}
 
 				prform = (Form_pg_publication_rel) GETSTRUCT(tup);
 				pubname = get_publication_name(prform->prpubid, false);
@@ -3395,8 +3535,10 @@ getObjectDescription(const ObjectAddress *object)
 
 		case OCLASS_SUBSCRIPTION:
 			{
-				appendStringInfo(&buffer, _("subscription %s"),
-								 get_subscription_name(object->objectId, false));
+				char *subname = get_subscription_name(object->objectId, missing_ok);
+
+				if (subname)
+					appendStringInfo(&buffer, _("subscription %s"), subname);
 				break;
 			}
 
@@ -3408,8 +3550,12 @@ getObjectDescription(const ObjectAddress *object)
 				trfTup = SearchSysCache1(TRFOID,
 										 ObjectIdGetDatum(object->objectId));
 				if (!HeapTupleIsValid(trfTup))
+				{
+					if (missing_ok)
+						break;
 					elog(ERROR, "could not find tuple for transform %u",
 						 object->objectId);
+				}
 
 				trfForm = (Form_pg_transform) GETSTRUCT(trfTup);
 
@@ -3427,6 +3573,10 @@ getObjectDescription(const ObjectAddress *object)
 			 */
 	}
 
+	/* an empty buffer is equivalent to no object found */
+	if (buffer.len == 0)
+		return NULL;
+
 	return buffer.data;
 }
 
@@ -3442,14 +3592,14 @@ getObjectDescriptionOids(Oid classid, Oid objid)
 	address.objectId = objid;
 	address.objectSubId = 0;
 
-	return getObjectDescription(&address);
+	return getObjectDescription(&address, false);
 }
 
 /*
  * subroutine for getObjectDescription: describe a relation
  */
 static void
-getRelationDescription(StringInfo buffer, Oid relid)
+getRelationDescription(StringInfo buffer, Oid relid, bool missing_ok)
 {
 	HeapTuple	relTup;
 	Form_pg_class relForm;
@@ -3459,7 +3609,11 @@ getRelationDescription(StringInfo buffer, Oid relid)
 	relTup = SearchSysCache1(RELOID,
 							 ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(relTup))
+	{
+		if (missing_ok)
+			return;
 		elog(ERROR, "cache lookup failed for relation %u", relid);
+	}
 	relForm = (Form_pg_class) GETSTRUCT(relTup);
 
 	/* Qualify the name if not visible in search path */
@@ -3519,7 +3673,7 @@ getRelationDescription(StringInfo buffer, Oid relid)
  * subroutine for getObjectDescription: describe an operator family
  */
 static void
-getOpFamilyDescription(StringInfo buffer, Oid opfid)
+getOpFamilyDescription(StringInfo buffer, Oid opfid, bool missing_ok)
 {
 	HeapTuple	opfTup;
 	Form_pg_opfamily opfForm;
@@ -3529,7 +3683,11 @@ getOpFamilyDescription(StringInfo buffer, Oid opfid)
 
 	opfTup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfid));
 	if (!HeapTupleIsValid(opfTup))
+	{
+		if (missing_ok)
+			return;
 		elog(ERROR, "cache lookup failed for opfamily %u", opfid);
+	}
 	opfForm = (Form_pg_opfamily) GETSTRUCT(opfTup);
 
 	amTup = SearchSysCache1(AMOID, ObjectIdGetDatum(opfForm->opfmethod));
@@ -3573,7 +3731,11 @@ pg_describe_object(PG_FUNCTION_ARGS)
 	address.objectId = objid;
 	address.objectSubId = objsubid;
 
-	description = getObjectDescription(&address);
+	description = getObjectDescription(&address, true);
+
+	if (description == NULL)
+		PG_RETURN_NULL();
+
 	PG_RETURN_TEXT_P(cstring_to_text(description));
 }
 
@@ -3588,6 +3750,8 @@ pg_identify_object(PG_FUNCTION_ARGS)
 	int32		objsubid = PG_GETARG_INT32(2);
 	Oid			schema_oid = InvalidOid;
 	const char *objname = NULL;
+	char	   *objtype;
+	char	   *objidentity;
 	ObjectAddress address;
 	Datum		values[4];
 	bool		nulls[4];
@@ -3661,8 +3825,14 @@ pg_identify_object(PG_FUNCTION_ARGS)
 	}
 
 	/* object type */
-	values[0] = CStringGetTextDatum(getObjectTypeDescription(&address));
-	nulls[0] = false;
+	objtype = getObjectTypeDescription(&address, true);
+	if (objtype)
+	{
+		values[0] = CStringGetTextDatum(getObjectTypeDescription(&address, false));
+		nulls[0] = false;
+	}
+	else
+		nulls[0] = true;
 
 	/* schema name */
 	if (OidIsValid(schema_oid))
@@ -3685,8 +3855,14 @@ pg_identify_object(PG_FUNCTION_ARGS)
 		nulls[2] = true;
 
 	/* object identity */
-	values[3] = CStringGetTextDatum(getObjectIdentity(&address));
-	nulls[3] = false;
+	objidentity = getObjectIdentity(&address, true);
+	if (objidentity)
+	{
+		values[3] = CStringGetTextDatum(getObjectIdentity(&address, true));
+		nulls[3] = false;
+	}
+	else
+		nulls[3] = true;
 
 	htup = heap_form_tuple(tupdesc, values, nulls);
 
@@ -3703,6 +3879,7 @@ pg_identify_object_as_address(PG_FUNCTION_ARGS)
 	Oid			objid = PG_GETARG_OID(1);
 	int32		objsubid = PG_GETARG_INT32(2);
 	ObjectAddress address;
+	char	   *type;
 	char	   *identity;
 	List	   *names;
 	List	   *args;
@@ -3730,23 +3907,37 @@ pg_identify_object_as_address(PG_FUNCTION_ARGS)
 	tupdesc = BlessTupleDesc(tupdesc);
 
 	/* object type */
-	values[0] = CStringGetTextDatum(getObjectTypeDescription(&address));
-	nulls[0] = false;
+	type = getObjectTypeDescription(&address, true);
+	if (type)
+	{
+		values[0] = CStringGetTextDatum(getObjectTypeDescription(&address, false));
+		nulls[0] = false;
+	}
+	else
+		nulls[0] = true;
 
 	/* object identity */
-	identity = getObjectIdentityParts(&address, &names, &args);
-	pfree(identity);
+	identity = getObjectIdentityParts(&address, &names, &args, true);
+	if (identity == NULL)
+	{
+		nulls[1] = true;
+		nulls[2] = true;
+	}
+	else
+	{
+		pfree(identity);
 
-	/* object_names */
-	values[1] = PointerGetDatum(strlist_to_textarray(names));
-	nulls[1] = false;
+		/* object_names */
+		values[1] = PointerGetDatum(strlist_to_textarray(names));
+		nulls[1] = false;
 
-	/* object_args */
-	if (args)
-		values[2] = PointerGetDatum(strlist_to_textarray(args));
-	else
-		values[2] = PointerGetDatum(construct_empty_array(TEXTOID));
-	nulls[2] = false;
+		/* object_args */
+		if (args)
+			values[2] = PointerGetDatum(strlist_to_textarray(args));
+		else
+			values[2] = PointerGetDatum(construct_empty_array(TEXTOID));
+		nulls[2] = false;
+	}
 
 	htup = heap_form_tuple(tupdesc, values, nulls);
 
@@ -3760,7 +3951,7 @@ pg_identify_object_as_address(PG_FUNCTION_ARGS)
  * Keep ObjectTypeMap in sync with this.
  */
 char *
-getObjectTypeDescription(const ObjectAddress *object)
+getObjectTypeDescription(const ObjectAddress *object, bool missing_ok)
 {
 	StringInfoData buffer;
 
@@ -3770,11 +3961,13 @@ getObjectTypeDescription(const ObjectAddress *object)
 	{
 		case OCLASS_CLASS:
 			getRelationTypeDescription(&buffer, object->objectId,
-									   object->objectSubId);
+									   object->objectSubId,
+									   missing_ok);
 			break;
 
 		case OCLASS_PROC:
-			getProcedureTypeDescription(&buffer, object->objectId);
+			getProcedureTypeDescription(&buffer, object->objectId,
+										missing_ok);
 			break;
 
 		case OCLASS_TYPE:
@@ -3790,7 +3983,8 @@ getObjectTypeDescription(const ObjectAddress *object)
 			break;
 
 		case OCLASS_CONSTRAINT:
-			getConstraintTypeDescription(&buffer, object->objectId);
+			getConstraintTypeDescription(&buffer, object->objectId,
+										 missing_ok);
 			break;
 
 		case OCLASS_CONVERSION:
@@ -3927,6 +4121,10 @@ getObjectTypeDescription(const ObjectAddress *object)
 			 */
 	}
 
+	/* an empty string is equivalent to no object found */
+	if (buffer.len == 0)
+		return NULL;
+
 	return buffer.data;
 }
 
@@ -3934,7 +4132,8 @@ getObjectTypeDescription(const ObjectAddress *object)
  * subroutine for getObjectTypeDescription: describe a relation type
  */
 static void
-getRelationTypeDescription(StringInfo buffer, Oid relid, int32 objectSubId)
+getRelationTypeDescription(StringInfo buffer, Oid relid, int32 objectSubId,
+						   bool missing_ok)
 {
 	HeapTuple	relTup;
 	Form_pg_class relForm;
@@ -3942,7 +4141,14 @@ getRelationTypeDescription(StringInfo buffer, Oid relid, int32 objectSubId)
 	relTup = SearchSysCache1(RELOID,
 							 ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(relTup))
+	{
+		if (missing_ok)
+		{
+			Assert(buffer->len == 0);
+			return;
+		}
 		elog(ERROR, "cache lookup failed for relation %u", relid);
+	}
 	relForm = (Form_pg_class) GETSTRUCT(relTup);
 
 	switch (relForm->relkind)
@@ -3988,7 +4194,7 @@ getRelationTypeDescription(StringInfo buffer, Oid relid, int32 objectSubId)
  * subroutine for getObjectTypeDescription: describe a constraint type
  */
 static void
-getConstraintTypeDescription(StringInfo buffer, Oid constroid)
+getConstraintTypeDescription(StringInfo buffer, Oid constroid, bool missing_ok)
 {
 	Relation	constrRel;
 	HeapTuple	constrTup;
@@ -3997,7 +4203,14 @@ getConstraintTypeDescription(StringInfo buffer, Oid constroid)
 	constrRel = heap_open(ConstraintRelationId, AccessShareLock);
 	constrTup = get_catalog_object_by_oid(constrRel, constroid);
 	if (!HeapTupleIsValid(constrTup))
+	{
+		if (missing_ok)
+		{
+			heap_close(constrRel, AccessShareLock);
+			return;
+		}
 		elog(ERROR, "cache lookup failed for constraint %u", constroid);
+	}
 
 	constrForm = (Form_pg_constraint) GETSTRUCT(constrTup);
 
